<?php

require_once('base_widget.php');
require_once('select.php');
require_once('string.php');

/**
 * String widget, with a list of common shortcuts for action_url paths
 */
class actionurl_widget extends base_widget {
	/**
	 * List of url shortcuts
	 */
	var $protocols = array(
		'telnet://$HOSTADDRESS$' => 'telnet',
		'http://$HOSTADDRESS$' => 'http',
		'https://$HOSTADDRESS$' => 'https',
		'ftp://$HOSTADDRESS$' => 'ftp',
		'ssh://$HOSTADDRESS$' => 'ssh',
		'rdp://$HOSTADDRESS$' => 'rdp',
	);

	function render($obj, $token, $value) {
		$selid = preg_replace('/[^a-z0-9]+/', '_', $this->get_id($obj, $token).'select');
		echo '<select id="'.$selid.'">';
		echo '<option selected="selected" value=""></option>';
		foreach ($this->protocols as $v => $protocol) {
			echo '<option value="'.$v.'">'.$protocol.'</option>';
		}
		echo '</select>';
		$string = new string_widget();
		$string->render($obj, $token, $value);
		echo "<script type=\"text/javascript\">
			$('select#{$selid}').change(function() {
				$('input#".preg_replace('/([\[\]])/', "\\\\\\\\\\1", $this->get_id($obj, $token))."').val(this.value);
			});
			$('input#".preg_replace('/([\[\]])/', "\\\\\\\\\\1", $this->get_id($obj, $token))."').keydown(function() {
				$('select#{$selid}').val('');
			});
		</script>";
	}

	static function validate($obj, $token, $value) {
		return string_widget::validate($obj, $token, $value);
	}
}
